#ifndef GRAPH_UTIL
#define GRAPH_UTIL

#include <GL/glut.h>
#include "graph_util.h"


#define PHI 3.1415926535f
#define sqr(x) ((x)*(x))
#define swapGLfloat(a, b) { GLfloat pom = a; a = b; b = pom; }
#define min(a, b) (((a) < (b))?(a) :(b))
#define DIM 4

//---------------------------------------------------------------------
// Tato funkce vykresli retezec zadanym bitmapovym fontem
//---------------------------------------------------------------------
void printfGlutBitmapFont(void *font, char *format, ...);
void printfGlutBitmapFont(int x, int y, GLfloat *color, void *font, char *format, ...);


//---------------------------------------------------------------------
// Tato funkce vykresli retezec zadanym stroke fontem
//---------------------------------------------------------------------
void printfGlutStrokeFont(GLfloat *rot, GLfloat *scale, void *font, char *format, ...);


/* glmCross: compute the cross product of two vectors
 *
 * u - array of 3 GLfloats (GLfloat u[3])
 * v - array of 3 GLfloats (GLfloat v[3])
 * n - array of 3 GLfloats (GLfloat n[3]) to return the cross product in
 */
GLvoid crossProduct(GLfloat* u, GLfloat* v, GLfloat* n);



/* glmNormalize: normalize a vector
 *
 * v - array of 3 GLfloats (GLfloat v[3]) to be normalized
 */
void normalize(GLfloat* v);



//---------------------------------------------------------------------
// Funkce pro vynasobeni vektoru skalarem
//---------------------------------------------------------------------
void multVectByScalar(GLfloat* v, GLfloat scalar);



//---------------------------------------------------------------------
// Pretransformovani vrcholu matici matrix[16]
//---------------------------------------------------------------------
void transfVertex(GLdouble *matrix, GLfloat *vertex);



//---------------------------------------------------------------------
// Upravena pomocna funkce pro aplikaci zpetne projekce. Pro bod zadany
// v souradnicich obrazovky [x, y] se vypocte odpovidajici bod ve
// svetovych souradnicich [xw, yw, zw]. Z-ova souradnice bodu na obra-
// zovce je vypoctena z hloubky ulozene ve framebufferu.
//---------------------------------------------------------------------
void unProject3D(GLfloat x, GLfloat y,
				 GLfloat *xw, GLfloat *yw, GLfloat *zw);



//---------------------------------------------------------------------
// Upravena pomocna funkce pro aplikaci zpetne projekce. Pro bod zadany
// v souradnicich obrazovky [x, y] se vypocte odpovidajici bod ve
// svetovych souradnicich [xw, yw, zw]. Z-ova souradnice bodu na obra-
// zovce je vypoctena z hloubky ulozene ve framebufferu.
//---------------------------------------------------------------------
void unProject2D(GLfloat x, GLfloat y,
				 GLfloat *xw, GLfloat *yw);


#endif