//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
int knotWidth = 400, knotHeight = 170;
GLfloat knotScale = 10.f;
GLfloat translKnot[] = { 0.f, 0.f };


static GLfloat kcx = 0, kcy = 0;

static int knotMouseX = 0, knotMouseY = 0;

static int knotHitId = -1;

float bazFce(const int order, const float t, const int i) 
{
	float a, b, res;

	if (order == 1) return ((knotVector[i] <= t) 
		&& (t < knotVector[i+1])) ?1.f :0.f;

	a = t -knotVector[i];
	b = knotVector[i+order-1] - knotVector[i];
	res = (b==0) ?0.f :bazFce(order-1, t, i) * a / b;

	a = knotVector[i+order] -t;
	b = knotVector[i+order] - knotVector[i+1];
	res += (b==0) ?0.f :bazFce(order-1, t, i+1) * a / b;

	return res;
}


void drawBazFce(int order, GLfloat y) 
{
	glPushMatrix();
	glTranslatef(translKnot[0], 0, 0);
		glTranslatef(0, y, 0);

	glColor4f(1, 1, 1, 1);
	glRasterPos2f(10.3f, 0.4f);
	printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_18, "%c", 'B');
	printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_10, "%d.", order);

	glScalef(knotScale, 1, 1);
	
	for (int i = 0; i < numberOfKnots-order; i++) {
		GLfloat y, yMax = 0, tMax = knotVector[i];
		glBegin(GL_LINE_STRIP);
			glColor4f(1, (GLfloat)i /(numberOfKnots-order+1), 0, 1);
			glVertex2f(knotVector[0], 0);
			for (GLfloat t = knotVector[0]; t <= knotVector[numberOfKnots-1]; t += 0.001) {
					if (yMax < (y = bazFce(order, t, i))) {
						yMax = y; tMax = t; }
					glVertex2f(t, y);
			}
			glVertex2f(knotVector[numberOfKnots-1], 0);
		glEnd();
		glRasterPos2f(tMax, yMax +.1);
		printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_10, "%d", i);
	}

	glPopMatrix();
}




void drawKnotVector(GLenum mode) 
{
	glColor4f(1, 1, 1, 1);

	if (mode == GL_RENDER) {
		glBegin(GL_LINES);
			glVertex2f(knotVector[0], 0.80);
			glVertex2f(knotVector[numberOfKnots-1], 0.80);
		glEnd();
	}
	
	glLineWidth(2);
	for (int i = numberOfKnots/2; 0 <= i; i--) {
		if (mode == GL_SELECT) 
			glLoadName (i); 
		glBegin(GL_LINE_STRIP);
			glColor4f(1, (GLfloat)i /(numberOfKnots-order+1), 0, 1);
			glVertex2f(knotVector[i], 0.70);
			glVertex2f(knotVector[i], 0.90);
		glEnd();
		glRasterPos2f(knotVector[i], 0.45);
		printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_10, "K%d", i);
	}
	for (int i = numberOfKnots/2+1; i < numberOfKnots; i++) {
		if (mode == GL_SELECT) 
			glLoadName (i); 
		glBegin(GL_LINE_STRIP);
			glColor4f(1, (GLfloat)i /(numberOfKnots-order+1), 0, 1);
			glVertex2f(knotVector[i], 0.70);
			glVertex2f(knotVector[i], 0.90);
		glEnd();
		glRasterPos2f(knotVector[i], 0.45);
		printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_10, "V%d", i);
	}
	glLineWidth(1);


	if (mode == GL_RENDER) {
		glRasterPos2f(.4, 0.1);
		printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_12, "order == %9d", order);
	}
    glColor4f(0, 1, 0, 1);

	if (mode == GL_SELECT) glLoadName(100);
	glBegin(GL_TRIANGLES);
		glVertex2f(.58, .1); glVertex2f(.58, .28); glVertex2f(.55, .19);
	glEnd();
	if (mode == GL_SELECT) glLoadName(101);
	glBegin(GL_TRIANGLES);
		glVertex2f(.68, .1); glVertex2f(.68, .28); glVertex2f(.71, .19);
	glEnd();

	
   
	if ((knotHitId !=-1) && (knotHitId < 100)) {
		glColor4f(1, (GLfloat)knotHitId /(numberOfKnots-order+1), 0, 1);
		glRasterPos2f(knotVector[knotHitId], 1.00);
		printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_10, 
			"%.3f", knotVector[knotHitId] -knotVector[knotHitId-1]);
		glRasterPos2f(knotVector[knotHitId], 1.25);
		printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_10, 
			"%.3f", knotVector[knotHitId]);
	}
}	



int pickKnot(void)
{
	GLuint selectBuf[BUFSIZE];
	GLint hits;
	GLint viewport[4];

	glGetIntegerv (GL_VIEWPORT, viewport);

	glSelectBuffer (BUFSIZE, selectBuf);
	glRenderMode (GL_SELECT);

	glInitNames();
	glPushName(-1);

	glMatrixMode (GL_PROJECTION);
	glPushMatrix ();
	glLoadIdentity ();
	/*  create 5x5 pixel picking region near cursor location	*/
	gluPickMatrix ((GLdouble) knotMouseX-0, (GLdouble) (viewport[3] - (knotMouseY-0)), 
					6.0, 6.0, viewport);
	gluOrtho2D(-0.3, 11, -1.5, 3);
	drawKnotVector(GL_SELECT);

	glMatrixMode (GL_PROJECTION);
	glPopMatrix ();
	glFlush ();

	hits = glRenderMode (GL_RENDER);
	printf("Hits = %d\n", hits);

	knotHitId = (0 < hits)? selectBuf[3] :-1;
	printf("knotHitId = %d\n", knotHitId);
	return hits;
//	processHits (hits, selectBuf);
//	glutPostRedisplay();
} 



//-------------------------------------------------------------------------
//
//-------------------------------------------------------------------------
static void knotReshape(int width,  int height) 
{
	knotWidth = width; knotHeight = height;
	glViewport(0, 0, width, height); 
    glClearColor(0.f, 0.f, 0.f, 1.f);
	
	glClearStencil(0); 
//		glEnable(GL_STENCIL_TEST);
//		glStencilFunc(GL_EQUAL, 0, ~0);

	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluOrtho2D(-0.3, 11, -1.5, 3);
}




static void knotDisplay(void) {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); // vymazani barvoveho a hloubkoveho bufferu
    glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

	glScissor(0, 1.5 /4.5*knotHeight -1, knotWidth, knotHeight -1.5 /4.5*knotHeight);
	glEnable(GL_SCISSOR_TEST);
		glTranslatef(translKnot[0], translKnot[1], 0);
		for (int i = order; 0 < i; i--) 
			drawBazFce(i, (order -i)*1.5);
	glDisable(GL_SCISSOR_TEST);

	glLoadIdentity();
		glTranslatef(0, -1.5, 0);
		glScalef(knotScale, 1, 1);
		drawKnotVector(GL_RENDER);

	glFlush();
    glutSwapBuffers();
}








//***************************************************************************	
//***************************************************************************	
//---------------------------------------------------------------------
// Tato funkce je volana pri posunu mysi bez stlaceneho tlacitka mysi
//---------------------------------------------------------------------

void knotMouseFunc(int button, int state, int x, int y) {
	knotMouseX = x; knotMouseY = y;

	if (state == GLUT_DOWN) {
		if ((knotHitId == 100) && (2 < order)) {
			numberOfKnots--;
			order--; 
			reDrawAll(); 
		}else if ((knotHitId == 101) && (order < 10)) {
			int min, max;
			for (min = 0;   knotVector[0] >= knotVector[min]; min++);
			for (max = min; knotVector[max] <  knotVector[numberOfCtrlPoints +order -1]; max++);
			GLfloat pomer = (GLfloat)(max -min +1) / (max -min +2);
			for ( ; min <= max; min++)
				knotVector[min] *= pomer;
	
			numberOfKnots++;
			knotVector[numberOfKnots -1] = 1.f;
			order++; 
			reDrawAll(); 
		}
	}

	modifiers = glutGetModifiers();
	mouseStatus = button;
}


void knotPassiveMotion(int x, int y) {
	knotMouseX = x; knotMouseY = y;
	static int hit = -1;
	//printf("  %d\n", knotHitId);
	if (pickKnot(), hit != knotHitId) {
		glScissor(0, 0.90 /4.5*knotHeight, knotWidth, (1.5-0.90) /4.5*knotHeight -1);
		glEnable(GL_SCISSOR_TEST);

		glDrawBuffer(GL_FRONT);

		if ((knotHitId !=-1) && (knotHitId < 100)) {
			glColor4f(1, (GLfloat)knotHitId /(numberOfKnots-order+1), 0, 1);
			glRasterPos2f(knotVector[knotHitId], 1.00);
			if (knotHitId != 0) printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_10, 
				"%.3f", knotVector[knotHitId] -knotVector[knotHitId-1]);
			else 
				printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_10, "0.000");
			glRasterPos2f(knotVector[knotHitId], 1.25);
			printfGlutBitmapFont(GLUT_BITMAP_HELVETICA_10, 
				"%.3f", knotVector[knotHitId]);

		} else
			glClear(GL_COLOR_BUFFER_BIT);
		
		glDrawBuffer(GL_BACK);

		glDisable(GL_SCISSOR_TEST);
		hit = knotHitId;
	}
}

void knotMotionFunc(int x, int y) {
	switch (mouseStatus) {
		case GLUT_LEFT_BUTTON: 
		if ((knotHitId !=-1) && (knotHitId < 100)) {
			unProject2D((GLfloat)x, (GLfloat)(knotHeight-y), &kcx, &kcy);
			knotVector[knotHitId] = (0 <= kcx) ?((kcx <= 1) ?kcx :1) :0;
			if ((0 < knotHitId) && (knotHitId < numberOfKnots -1)) {
				while (knotVector[knotHitId-1] > knotVector[knotHitId]) {
					swapGLfloat(knotVector[knotHitId-1], knotVector[knotHitId]);
					knotHitId--; }
				while (knotVector[knotHitId] > knotVector[knotHitId+1]) {
					swapGLfloat(knotVector[knotHitId], knotVector[knotHitId+1]);
					knotHitId++; }
			} else
				if ((knotHitId == 0) && (knotVector[0] > knotVector[1])) 
					knotVector[0] = knotVector[1];
				else if ((knotHitId == numberOfKnots-1) && (knotVector[numberOfKnots-1] < knotVector[numberOfKnots-2])) 
						knotVector[numberOfKnots-1] =  knotVector[numberOfKnots-2];
			
			glutSetWindow(worldWindow);
				glutPostRedisplay();
			glutSetWindow(knotWindow);
			glutPostRedisplay();
		} break;

		case GLUT_MIDDLE_BUTTON: 
			translKnot[1] += (knotMouseY -y) *4.5/knotHeight;
			glutPostRedisplay();
			break;
	}

	knotMouseX = x; knotMouseY = y;
}


void knotKeyboardFunc(unsigned char k, int x, int y) { 
	int i = glutGetModifiers();
}


void knotMenu(int polozka) 
{
}







void knotInit(void) {
	knotWindow = glutCreateSubWindow(mainWindow, 
		WINDOW_WIDTH  -(  GAP +(WINDOW_WIDTH  -3*GAP)*4.5/10), 
		WINDOW_HEIGHT -(2*GAP +(WINDOW_HEIGHT -4*GAP)*4. /10),
		knotWidth, knotHeight);
	glutReshapeFunc(knotReshape);
	glutDisplayFunc( (void (*)(void))knotDisplay);
	glutPassiveMotionFunc(knotPassiveMotion);
	glutMouseFunc(knotMouseFunc);
	glutMotionFunc(knotMotionFunc);
//	glutKeyboardFunc(knotKeyboardFunc);

	int knotMenuId = glutCreateMenu(knotMenu);
	glutAddMenuEntry("Set order 2", 2);
	glutAddMenuEntry("Set order 3", 3);
	glutAddMenuEntry("Set order 4", 4);
	glutAddMenuEntry("Set order 5", 5);
	glutAddMenuEntry("Set order 6", 6);
	glutAddMenuEntry("Set order 7", 7);
	glutAddMenuEntry("Set order 8", 8);
//	glutAttachMenu(GLUT_RIGHT_BUTTON);
	glutSetCursor(GLUT_CURSOR_FULL_CROSSHAIR);
}