//////////////////////////////////////////////////////////////////////////////////////////////
////////////// Transformacni funkce //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////


#include <stdio.h>

#define CTRL_POINT_MAX 100
#define KNOT_MAX 100

GLfloat ctrlPoints[CTRL_POINT_MAX *sizeof(vertex4f)];
unsigned numberOfCtrlPoints = 0;
GLfloat knots[KNOT_MAX];
unsigned order = 3;


typedef enum { ADD_POINTS, DELETE_POINTS, 
	POLYGON, EDIT_MODE } tOperations;

operations tOperations = EDIT_MODE;


class NurbsObject {
	protected:
		typedef struct {
			GLfloat x, y, z, w; } vertex4f;
		
		GLfloat ctrlPoints[CTRL_POINT_MAX *sizeof(vertex4f)];
		unsigned numberOfCtrlPoints = 0;
		GLfloat knots[KNOT_MAX];
		unsigned order = 3;

	public:
		NurbsObject(void) = {};
		void addCtrlPoint(GLfloat x, GLfloat y, 
			GLfloat z = 0, GLfloat w = 1);
		void draw(GLenum mode);
};


void NurbsObject::addCtrlPoint(GLfloat x, GLfloat y, 
					  GLfloat z = 0, GLfloat w = 1) 
{
	ctrlPoints[numberOfCtrlPoints].x = x;
	ctrlPoints[numberOfCtrlPoints].y = y;
	ctrlPoints[numberOfCtrlPoints].z = z;
	ctrlPoints[numberOfCtrlPoints].w = w;
	numberOfCtrlPoints++;
}


bool NurbsObject::draw(GLenum mode)
GLbyte bitmap[] = { 0xF0, 0x90, 0x90, 0xF0 }; 
{
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glColor4f(1, 1, 0, 1);
	for (int i = 0; i< numberOfCtrlPoints; i++) {
		if (mode == GL_SELECT) glLoadName (i); 
		glRasterPos2f(ctrlPoints[i].x, ctrlPoints[i].y);
		glBitmap(4, 4, -2, -2, 0, 0, bitmap);
	}
}




}

#endif